package com.cool.hot100.dp;

import org.junit.Test;

import java.util.*;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/24/16:11
 * DayNumber 2
 * Hard 2
 * Level ?
 * @Description 139. 单词拆分
 * @Link https://leetcode.cn/problems/word-break/description/?envType=study-plan-v2&envId=top-100-liked
 */
public class Num139 {
    public boolean wordBreak(String s, List<String> wordDict) {
        Set<String> wordDictSet = new HashSet(wordDict);
        boolean[] dp = new boolean[s.length() + 1];
        Arrays.fill(dp, false);
        dp[0] = true;
        // dp[i]表示从0-i的字符串，是否可以用wordDict来表示
        for(int i=1;i<s.length()+1;i++){
            for(int j=0;j<i;j++){
                if(dp[j]&&wordDictSet.contains(s.substring(j,i))){
                    dp[i]=true;
                    break;
                }
            }
        }
        return dp[s.length()];
    }

    @Test
    public void test(){
        List<String> list=new ArrayList<>();
        list.add("leet");
        list.add("code");

        wordBreak("leetcode",list);
    }
}
