package com.cool.hot100.dp;

import org.junit.Test;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/26/09:31
 * DayNumber 1
 * Hard 2
 * Level ?
 * @Description 416. 分割等和子集
 * @Link https://leetcode.cn/problems/partition-equal-subset-sum/description/?envType=study-plan-v2&envId=top-100-liked
 */
public class Num416 {
    public boolean canPartition(int[] nums) {
        int average = 0;
        for (int num : nums) {
            average += num;
        }
        if ((average & 1) == 1) {
            return false;
        }
        average = average / 2;
        boolean[] dp = new boolean[average + 1];
        if (nums[0] <= average) {
            dp[nums[0]] = true;
        }
        for (int i = 1; i < nums.length; i++) {
            for (int j = average; nums[i] <= j; j--) {
                dp[j] = dp[j] || dp[j - nums[i]];
                if (dp[average]) {
                    return true;
                }
            }
        }
        return dp[average];
    }

    @Test
    public void test(){
        canPartition(new int[]{1,2,5});
    }
}
