package com.cool.hot100.binary_tree;

import org.junit.Test;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/01/17:17
 * DayNumber 1
 * Hard 2
 * Level 3
 */
public class Num114 {
    public void flatten(TreeNode root) {
//        while (root != null) {
//            TreeNode right = root.right;
//            if (root.left != null) {
//                TreeNode left = root.left;
//                while (left.right != null) {
//                    left = left.right;
//                }
//                root.right = root.left;
//                left.right = right;
//            }
//            root.left = null;
//            root = root.right;
//        }
        dfs(root);
    }

    private TreeNode dfs(TreeNode root) {
        if (root == null) return null;
        TreeNode returnRoot = root;
        TreeNode right = dfs(root.right);
        TreeNode left = dfs(root.left);
        root.left = null;
        if (left != null) {
            root.right = left;
        }
        if (left != null && right != null) {
            while (root.right!=null){
                root=root.right;
            }
            root.right = right;
        } else if (right != null) {
            root.right = right;
        }
        return returnRoot;
    }

    @Test
    public void test() {
        TreeNode node1 = new TreeNode(6);
        TreeNode node2 = new TreeNode(2);
        TreeNode node3 = new TreeNode(4);
        TreeNode node4 = new TreeNode(3);
        TreeNode node5 = new TreeNode(5);
        TreeNode node6 = new TreeNode(2);
        TreeNode node7 = new TreeNode(1);
        node7.left = node6;
        node7.right = node5;
        node6.left = node4;
        node6.right = node3;
        node5.right = node1;
        flatten(node7);
    }

}
