package com.cool.ling_cha_mount.sliding_windows;

import java.util.Arrays;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/10/05/16:34
 * @Description: 2090. 半径为 k 的子数组平均值
 * DayNumber 1
 * Hard 2
 * Level 3
 * Score 1358
 */
public class Num2090 {

    public int[] getAverages(int[] nums, int k) {
        int[] res=new int[nums.length];
        Arrays.fill(res,-1);
        int num=2*k+1;
        if(nums.length<num){
            return res;
        }
        long sum=0;
        for(int i=0;i<num;i++){
            sum+=nums[i];
        }

        res[k]=(int)(sum/num);

        for(int i=k+1;i+k<nums.length;i++){
            sum-=nums[i-(k+1)];
            sum+=nums[i+k];
            res[i]=(int)(sum/num);
        }
        return res;
    }
}
