package com.cool.one_question_per_day;

import java.util.Arrays;
import java.util.PriorityQueue;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/30/20:24
 * DayNumber 3
 * Level 3
 * Score 1429
 * Hard 2
 * @link https://leetcode.cn/problems/seat-reservation-manager/description/?envType=daily-question&envId=2024-09-30
 * @Description 1845. 座位预约管理系统
 */
public class SeatManager {
    private final PriorityQueue<Integer> available = new PriorityQueue<>();
    private int seats;

    public SeatManager(int n) {
    }

    public int reserve() {
        if (!available.isEmpty()) { // 有空出来的椅子
            return available.poll(); // 坐编号最小的
        }
        return ++seats; // 添加一把新的椅子
    }

    public void unreserve(int seatNumber) {
        available.add(seatNumber); // 有人离开了椅子
    }


//    boolean[] manager;
//    int minIndex = 0;
//
//    public SeatManager(int n) {
//        manager = new boolean[n];
//        Arrays.fill(manager, true);
//    }
//
//    public int reserve() {
//        if (minIndex < manager.length) {
//            while (!manager[minIndex]) {
//                Q
//                minIndex++;
//            }
//            manager[minIndex++] = false;
//        }
//        return minIndex;
//    }
//
//    public void unreserve(int seatNumber) {
//        manager[seatNumber - 1] = true;
//        minIndex = Math.min(minIndex, seatNumber - 1);
//    }

}
